<?php
namespace Bitfoundry\Etnpay\Controller\Scan;

class Etnconfirmation extends \Bitfoundry\Etnpay\Controller\AbstractEtnpay
{

    public function execute()
    {
        $etnpay = $this->_paymentMethod;
        $helper = $this->helper;

        $paymentId = $this->_request->getParam('paymentid');
        // get payment confirmation from Electroneum API to confirm order
        $vendorAddress = $etnpay->getVendorAddress();
        $apiKey = $etnpay->getApiKey();
        $apiSecret = $etnpay->getApiSecret();
        $payload = [
            'payment_id' => '0' . $paymentId,
            'vendor_address' => 'etn-it-' . $vendorAddress
        ];

        $etnSignature = $helper->createSecuritySignature($payload, $apiSecret);
        $etnUrl = 'https://poll.electroneum.com/vendor/check-payment';

        $ch = curl_init($etnUrl);
        curl_setopt($ch, CURLOPT_HTTPHEADER, [
            'Content-Type: application/json',
            'ETN-SIGNATURE: ' . $etnSignature
        ]);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($payload));
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        $result = curl_exec($ch);
        curl_close($ch);

        $this->getResponse()->setHeader('Content-type', 'application/json');
        $this->getResponse()->setBody($result);
    }
}
