<?php
namespace Bitfoundry\Etnpay\Model;

class Config extends AbstractConfig
{
    const METHOD_CODE = 'etnpay';

    protected $directoryHelper;
    protected $_storeManager;
    protected $_supportedBuyerCountryCodes = [
        'AF ',
        'AX ',
        'AL ',
        'DZ ',
        'AS ',
        'AD ',
        'AO ',
        'AI ',
        'AQ ',
        'AG ',
        'AR ',
        'AM ',
        'AW ',
        'AU ',
        'AT ',
        'AZ ',
        'BS ',
        'BH ',
        'BD ',
        'BB ',
        'BY ',
        'BE ',
        'BZ ',
        'BJ ',
        'BM ',
        'BT ',
        'BO ',
        'BA ',
        'BW ',
        'BV ',
        'BR ',
        'IO ',
        'BN ',
        'BG ',
        'BF ',
        'BI ',
        'KH ',
        'CM ',
        'CA ',
        'CV ',
        'KY ',
        'CF ',
        'TD ',
        'CL ',
        'CN ',
        'CX ',
        'CC ',
        'CO ',
        'KM ',
        'CG ',
        'CD ',
        'CK ',
        'CR ',
        'CI ',
        'HR ',
        'CU ',
        'CY ',
        'CZ ',
        'DK ',
        'DJ ',
        'DM ',
        'DO ',
        'EC ',
        'EG ',
        'SV ',
        'GQ ',
        'ER ',
        'EE ',
        'ET ',
        'FK ',
        'FO ',
        'FJ ',
        'FI ',
        'FR ',
        'GF ',
        'PF ',
        'TF ',
        'GA ',
        'GM ',
        'GE ',
        'DE ',
        'GH ',
        'GI ',
        'GR ',
        'GL ',
        'GD ',
        'GP ',
        'GU ',
        'GT ',
        'GG ',
        'GN ',
        'GW ',
        'GY ',
        'HT ',
        'HM ',
        'VA ',
        'HN ',
        'HK ',
        'HU ',
        'IS ',
        'IN ',
        'ID ',
        'IR ',
        'IQ ',
        'IE ',
        'IM ',
        'IL ',
        'IT ',
        'JM ',
        'JP ',
        'JE ',
        'JO ',
        'KZ ',
        'KE ',
        'KI ',
        'KP ',
        'KR ',
        'KW ',
        'KG ',
        'LA ',
        'LV ',
        'LB ',
        'LS ',
        'LR ',
        'LY ',
        'LI ',
        'LT ',
        'LU ',
        'MO ',
        'MK ',
        'MG ',
        'MW ',
        'MY ',
        'MV ',
        'ML ',
        'MT ',
        'MH ',
        'MQ ',
        'MR ',
        'MU ',
        'YT ',
        'MX ',
        'FM ',
        'MD ',
        'MC ',
        'MN ',
        'MS ',
        'MA ',
        'MZ ',
        'MM ',
        'NA ',
        'NR ',
        'NP ',
        'NL ',
        'AN ',
        'NC ',
        'NZ ',
        'NI ',
        'NE ',
        'NG ',
        'NU ',
        'NF ',
        'MP ',
        'NO ',
        'OM ',
        'PK ',
        'PW ',
        'PS ',
        'PA ',
        'PG ',
        'PY ',
        'PE ',
        'PH ',
        'PN ',
        'PL ',
        'PT ',
        'PR ',
        'QA ',
        'RE ',
        'RO ',
        'RU ',
        'RW ',
        'SH ',
        'KN ',
        'LC ',
        'PM ',
        'VC ',
        'WS ',
        'SM ',
        'ST ',
        'SA ',
        'SN ',
        'CS ',
        'SC ',
        'SL ',
        'SG ',
        'SK ',
        'SI ',
        'SB ',
        'SO ',
        'ZA ',
        'GS ',
        'ES ',
        'LK ',
        'SD ',
        'SR ',
        'SJ ',
        'SZ ',
        'SE ',
        'CH ',
        'SY ',
        'TW ',
        'TJ ',
        'TZ ',
        'TH ',
        'TL ',
        'TG ',
        'TK ',
        'TO ',
        'TT ',
        'TN ',
        'TR ',
        'TM ',
        'TC ',
        'TV ',
        'UG ',
        'UA ',
        'AE ',
        'GB ',
        'US ',
        'UM ',
        'UY ',
        'UZ ',
        'VU ',
        'VE ',
        'VN ',
        'VG ',
        'VI ',
        'WF ',
        'EH ',
        'YE ',
        'ZM ',
        'ZW',
    ];
    protected $_supportedCurrencyCodes = [
        'AUD',
        'BRL',
        'CAD',
        'CDF',
        'CHF',
        'CLP',
        'CNY',
        'CZK',
        'DKK',
        'EUR',
        'GBP',
        'HKD',
        'HUF',
        'IDR',
        'ILS',
        'INR',
        'JPY',
        'KRW',
        'MXN',
        'MYR',
        'NOK',
        'NZD',
        'PHP',
        'PKR',
        'PLN',
        'RUB',
        'SEK',
        'SGD',
        'THB',
        'TRY',
        'TWD',
        'USD',
        'ZAR',
    ];
    protected $_urlBuilder;
    protected $_assetRepo;
    protected $etnpayHelper;

    public function __construct(
        \Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig,
        \Magento\Directory\Helper\Data $directoryHelper,
        \Magento\Store\Model\StoreManagerInterface $storeManager,
        \Magento\Framework\View\Asset\Repository $assetRepo,
        \Bitfoundry\Etnpay\Helper\Data $etnpayHelper
    ) {
        parent::__construct( $scopeConfig );
        $this->directoryHelper = $directoryHelper;
        $this->_storeManager   = $storeManager;
        $this->_assetRepo      = $assetRepo;
        $this->etnpayHelper = $etnpayHelper;

        $this->setMethod('etnpay');
        $currentStoreId = $this->_storeManager->getStore()->getStoreId();
        $this->setStoreId($currentStoreId);
    }

    public function isMethodAvailable( $methodCode = null )
    {
        return parent::isMethodAvailable( $methodCode );
    }

    public function getSupportedBuyerCountryCodes()
    {
        return $this->_supportedBuyerCountryCodes;
    }

    public function getMerchantCountry()
    {
        return $this->directoryHelper->getDefaultCountry( $this->_storeId );
    }

    public function isMethodSupportedForCountry( $method = null, $countryCode = null )
    {
        if ( $method === null ) {
            $method = $this->getMethodCode();
        }

        if ( $countryCode === null ) {
            $countryCode = $this->getMerchantCountry();
        }

        return in_array( $method, $this->getCountryMethods( $countryCode ) );
    }

    public function getCountryMethods( $countryCode = null )
    {
        $countryMethods = [
            'other' => [
                self::METHOD_CODE,
            ],

        ];
        if ( $countryCode === null ) {
            return $countryMethods;
        }
        return isset( $countryMethods[$countryCode] ) ? $countryMethods[$countryCode] : $countryMethods['other'];
    }

    public function getPaymentMarkImageUrl()
    {
        return $this->_assetRepo->getUrl( 'Bitfoundry_Etnpay::images/etn_payment_logo.png' );
    }

    public function getPaymentMarkWhatIsElectroneum()
    {
        return 'Electroneum Instant Payment';
    }

    public function getPaymentAction()
    {
        $paymentAction = null;
        $action = $this->getValue( 'paymentAction' );

        switch ( $action ) {
            case self::PAYMENT_ACTION_AUTH:
                $paymentAction = \Magento\Payment\Model\Method\AbstractMethod::ACTION_AUTHORIZE;
                break;
            case self::PAYMENT_ACTION_SALE:
                $paymentAction = \Magento\Payment\Model\Method\AbstractMethod::ACTION_AUTHORIZE_CAPTURE;
                break;
            case self::PAYMENT_ACTION_ORDER:
                $paymentAction = \Magento\Payment\Model\Method\AbstractMethod::ACTION_ORDER;
                break;
        }

        return $paymentAction;
    }

    public function getPaymentInstructions()
    {
        $helper = $this->etnpayHelper;
        $instructions = "";

        if ($helper->isMobile()) {
            $instructions = "You will be presented with an Electroneum QR code, tap it to open your Electroneum app.";
        }
        else {
            $instructions = "You will be presented with an Electroneum QR code to scan when you place the order.";
        }

        return $instructions;
    }

    public function isCurrencyCodeSupported( $code )
    {
        $supported = false;
        if ( in_array( $code, $this->_supportedCurrencyCodes ) ) {
            $supported = true;
        }

        return $supported;
    }

    protected function _getSupportedLocaleCode( $localeCode = null )
    {
        if ( !$localeCode || !in_array( $localeCode, $this->_supportedImageLocales ) ) {
            return 'en_US';
        }
        return $localeCode;
    }

    protected function _mapEtnpayFieldset( $fieldName )
    {
        return "payment/{$this->_methodCode}/{$fieldName}";
    }

    protected function _getSpecificConfigPath( $fieldName )
    {
        return $this->_mapEtnpayFieldset( $fieldName );
    }
}
